
		.global	__vectors

PINB		= 0x03
DDRD		= 0x0a
PORTD		= 0x0b

__vectors:
		rjmp	main
main:
		ldi	r16, 0xff
		out	DDRD, r16

		ldi	r16, 0x30	; first byte, '0'
		out	PORTD, r16

		ldi	r30, lo8(table)
		ldi	r31, hi8(table)

loop:		sbic	PINB, 0
		rjmp	loop

		lpm	r16, Z+
		out	PORTD, r16
		rjmp	loop

		; 6000	lda	$9d00		ad 00 9d
		; 6003	sta	$6000,x		9d 00 60
		; 6006	inx			e8
		; 6007	bne	$6000		d0 f7

		; 6009	inc	$6005		ee 05 60
		; 600c	bpl	$6000		10 f2

		; 600e	...application...

table:
		.byte	0x38,0xcd,0xc2,0xc3	; CBM8 backwards
		.byte	0x00,0x80		; boot vector

		; stage 1

		.byte	0xa9,0x03		; lda #$03
		.byte	0x8d,0x11,0xd0		; sta $d011

		.byte	0xa9,0xad		; lda #$ad
		.byte	0x8d,0x00,0x60		; sta $6000
		.byte	0xa9,0x00		; lda #$00
		.byte	0x8d,0x01,0x60		; sta $6001
		.byte	0x8d,0x04,0x60		; sta $6004
		.byte	0xa9,0x9d		; lda #$9d
		.byte	0x8d,0x02,0x60		; sta $6002
		.byte	0x8d,0x03,0x60		; sta $6003
		.byte	0xa9,0x60		; lda #$60
		.byte	0x8d,0x05,0x60		; sta $6005
		.byte	0xa9,0xe8		; lda #$e8
		.byte	0x8d,0x06,0x60		; sta $6006
		.byte	0xa9,0xd0		; lda #$d0
		.byte	0x8d,0x07,0x60		; sta $6007
		.byte	0xa9,0xf7		; lda #$f7
		.byte	0x8d,0x08,0x60		; sta $6008

		.byte	0xa2,0x09		; ldx #$09
		.byte	0x4c,0x00,0x60		; jmp $6000

		; stage 2

		.byte	0xee,0x05,0x60		; inc $6005
		.byte	0x10,0xf2		; bpl -14

		; application

		;.byte	0xee,0x20,0xd0
		;.byte	0xea
		;.byte	0xea
		;.byte	0xea
		;.byte	0xea
		;.byte	0xea
		;.byte	0x4c,0x0e,0x60

